// LL(1).cpp : Defines the entry point for the console application.
// (C) Proteus lawnmower-man@mail.ru

#include "stdio.h"
#include "vector"
#include "map"
#include "set"
#include "stack"
#include "queue"
#include "algorithm"


#define BOOL int
#define FILENAME_GR  "3.lex"
#define FILENAME_TST "x.test"
#define FILENAME_NEW "new_Gr.txt"
#define FILENAME_ERR "error.log"
#define FILENAME_TAB "table.txt"
#define FILENAME_SET "set.txt"
#define FILENAME_XML "dump.xml"
#define FILENAME_LOG "log.txt"

class tree_st {	//   (   )
public:
	int token; int id;
	std::vector<tree_st*>*child;
	tree_st(){ child=0; id=0;}
	tree_st(int t,int i) { token=t; id=i; child=0;}
	tree_st *Add(int t,int i) {
		if(!child) child=new std::vector<tree_st*>;
		tree_st *sub=new tree_st(t,i);
		child->push_back(sub);
		return sub;
	}
	int Count()
	{
		if(child) return child->size();
		return 0;
	}
}tree;




class str_item{		//   
	public:
		char*name;  int index; bool isEps; bool isTerm; bool isNative;
		str_item() { name=0;}
		str_item(char*sn,bool t,bool native=false) { 
			name=strdup(sn); isTerm=t; isEps=false; index=0;
			isNative=native;
		}
		~str_item() { 
			if(name) free(name);
		}
		str_item (const str_item &cls) { 
			name=strdup(cls.name); isTerm=cls.isTerm; 
			isEps=cls.isEps; index=cls.index;
			isNative=cls.isNative;
		}
};


class StrTable{	//   ( )
	std::vector<str_item>table;
public:
	int Find(char*name) {for(int n=0; n<table.size(); n++) if(!strcmp(table[n].name,name)) return n; return -1;}
	int Add(char*name,bool native=false)	//   
	{
		if(Find(name)<0) table.push_back(str_item(name,0,native));
		return table.size()-1;
	}
	int Get(char* name)	//    
	{
		int n=Find(name); if(n>=0)return n;
		table.push_back(str_item(name,1));
		return table.size()-1;
	}
	char* GetName(int index) { return table[index].name;}
	int Dup(int index)
	{
		int n;
		char buffer[100];	//   !!!
		for(n=1;;n++) {
			sprintf(buffer,"%s%d",GetName(index),n);
			if(Find(buffer)<0) break;
		}
		table.push_back(str_item(buffer,0));
		return table.size()-1;
	}
	void SetIndex(int y,int n) { table[y].index=n; }
	int GetIndex(int y) { return table[y].index; }
	bool isTerm(int y) { return table[y].isTerm; }
	int GetSize() { return table.size(); }
	void SetEpsilon(int y)	//          
	{
		table[y].isEps=1;
	}
	bool isEps(int y) { return table[y].isEps; }
	bool isNative(int y) { return table[y].isNative; }  //   ,      

}str;


class CharSet: public std::set<int> {	//  
public:
	CharSet() {}
	CharSet operator +=(int t) {
		insert(t);
		return *this;
	}
	CharSet operator +=(CharSet &obj) {
		for(std::set<int>::iterator ptr=obj.begin();ptr!=obj.end();ptr++)insert((*ptr));
		return *this;
	}
};


class gr_st {	//  
public:
	std::vector<int>line;
	CharSet first;
	CharSet follow;
	gr_st() {}
	gr_st(const gr_st &obj)
	{
		line=obj.line;
		first=obj.first;
		follow=obj.follow;
	}
	bool operator<(const gr_st &obj)
	{
		int n,a,b,c;
		a=line.size(); b=obj.line.size(); //if(!b) return false;
		c=a<b?a:b;
		for(n=0; n<c; n++) {
#ifdef _DEBUG
			if(strcmp(str.GetName(line[n]),str.GetName(obj.line[n]))<0) return true;
#else
			if(line[n]<obj.line[n]) return true;
#endif
			if(line[n]!=obj.line[n]) break;
		}
		if(n==c && b>a) return true;
		return false;
	}
};

typedef std::pair<int,int>pair_st;
std::map<pair_st,int>table;



class GR{
gr_st new_line;
public:
std::vector<gr_st>list;	// !!
	void New() {}
	void Add(int n) { 
		new_line.line.push_back(n);
	}
	void Close() {
		list.push_back(new_line);
		new_line.line.clear();
	}
	int Get(int y,int x) { if(x>=list[y].line.size()) return -1; return list[y].line[x];}
	int GetCount(int y) { return list[y].line.size(); }
	int GetSize() { return list.size(); }
	void Sort() { std::sort(list.begin(),list.end()); }
	void Add(int y,int n) {
		list[y].line.push_back(n);
	}
	void DelSecond(int y)
	{
		list[y].line.erase(list[y].line.begin());
	}
	void SetFirst(int y,int n)
	{
		list[y].line[0]=n;
	}
	void AddFirstByIndex(int y,int n) {
		if(list[y].line.size()>1) list[y].first+=n;
	}
	void AddFollowByIndex(int y,int n) {
		list[y].follow+=n;
	}
	bool AddFollowByType(int w,int n) {
		int c1,c2; c1=c2=0;
		int y=str.GetIndex(w);
		while(y<list.size()) {
			if(w!=Get(y,0)) break;
			c1+=list[y].follow.size();
			AddFollowByIndex(y,n);
			c2+=list[y].follow.size();
			y++;
		}
		return c1!=c2;
	}
	void MakeTable()
	{
		int x,y,t,c; std::set<int>::iterator ptr;
		//   
		FILE *file=fopen(FILENAME_SET,"wt");
		fprintf(file,"[FIRST]\n\n");
		for(y=0; y<list.size(); y++) {
			fprintf(file,"%d:%s|",y,str.GetName(Get(y,0)));
			for(ptr=list[y].first.begin(); ptr!=list[y].first.end(); ptr++) fprintf(file," %s",str.GetName((*ptr)) );
			putc('\n',file);
		}
		fprintf(file,"\n[FORLOW]\n\n");
		for(y=0; y<list.size(); y++) {
			fprintf(file,"%d:%s|",y,str.GetName(Get(y,0)));
			for(ptr=list[y].follow.begin(); ptr!=list[y].follow.end(); ptr++) fprintf(file," %s",str.GetName((*ptr)) );
			putc('\n',file);
		}
		fclose(file);
		for(y=0; y<list.size(); y++) {
			c=GetCount(y); 
			//  
			if(c) {
				for(ptr=list[y].first.begin(); ptr!=list[y].first.end(); ptr++) {
					pair_st p(Get(y,0),(*ptr));
					if(table.find(p)!=table.end() && table[p]!=y) 
						printf("Err.Table first already (%d,%d)\n",(int)table[p],y);
					table[p]=y; 
				}
			}
			// Epsilon 
			t=1; for(x=1; x<c; x++) if(str.isEps(Get(y,x))) t++; c-=t;
			if(c) continue;
			for(ptr=list[y].follow.begin(); ptr!=list[y].follow.end(); ptr++) {
				pair_st p(Get(y,0),(*ptr));
				if(table.find(p)!=table.end() && table[p]!=y) 
					printf("Err.Table follow already (%d,%d)\n",(int)table[p],y);
				table[p]=y;
			}
		}
	}
	bool CopyFirstTypeToFirstIndex(int w,int i)	//  first (w1,w2  )
	{
		int c1,c2,y;
		y=str.GetIndex(w);	//  
		c1=list[i].first.size();
		while(y<list.size()) {	
			if(w!=Get(y,0)) break;
			list[i].first+=list[y].first;y++;
		}
		c2=list[i].first.size();
		return c1!=c2;
	}
	bool CopyFollowIndexToFollowName(int i,int w)
	{
		int y,c1,c2;
		c1=c2=0;
		y=str.GetIndex(w);
		while(y<list.size()) {	
			if(w!=Get(y,0)) break;
			c1+=list[y].follow.size();
			list[y].follow+=list[i].follow;
			c2+=list[y].follow.size();
			y++;
		}
		return c1!=c2;
	}
	bool CopyFirstToFollowByType(int w1,int w2)
	{
		int c1,c2,y;
		CharSet my;	//  
		y=str.GetIndex(w1);	//  
		while(y<list.size()) {	
			if(w1!=Get(y,0)) break;
			my+=list[y].first; y++;
		}
		y=str.GetIndex(w2);	c1=c2=0; //  
		while(y<list.size()) {
			if(w2!=Get(y,0)) break;
			c1+=list[y].follow.size();
			list[y].follow+=my;
			c2+=list[y].follow.size(); y++;
		}
		return c1!=c2;
	}
	bool CopyFollowToFollowByType(int w1,int w2)
	{
		int c1,c2,y;
		CharSet my;	//  
		y=str.GetIndex(w1);	//  
		while(y<list.size()) {	
			if(w1!=Get(y,0)) break;
			my+=list[y].follow;	y++;
		}
		y=str.GetIndex(w2);	c1=c2=0; //  
		while(y<list.size()) {
			if(w2!=Get(y,0)) break;
			c1+=list[y].follow.size();
			list[y].follow+=my;
			c2+=list[y].follow.size(); y++;
		}
		return c1!=c2;
	}
}gr_list;




 
//   ()

void Dump_Pr(int n,FILE *file=stdout)	//     
{
//	int t=gr_list.Get(0,0);
	fprintf(file,"%s:",str.GetName(gr_list.Get(n,0)));
	for(int m=1; m<gr_list.GetCount(n); m++) fprintf(file," %s",str.GetName(gr_list.Get(n,m)));
}

void Dump_Gr(FILE *file=stdout)
{
	for(int n=0; n<gr_list.GetSize(); n++) fprintf(file,"%d| ",n),Dump_Pr(n,file),putc('\n',file);
}

void Dump_Tab(FILE *file=stdout)
{
	int count1,count2;
	count1=count2=0;
	int x,y;
	for(x=0; x<str.GetSize(); x++) {if(str.isTerm(x)) fprintf(file,"|%s",str.GetName(x));}
	putc('\n',file);
	for(y=0; y<str.GetSize(); y++) {
		if(str.isTerm(y)) continue;
		fprintf(file,"%s",str.GetName(y));
		for(x=0; x<str.GetSize(); x++) {
			if(!str.isTerm(x)) continue;
			putc('|',file);
			if(table.find(pair_st(y,x))!=table.end()) Dump_Pr(table[pair_st(y,x)],file),count2++;
			count1++;
		}
		putc('\n',file);
	}
}


//   
void ReadGR()
{
	char *ref,buffer[100];	//    ;(
//   
	FILE *file=fopen(FILENAME_GR,"rt");
	while(!feof(file)) 
	{
		fscanf(file,"%s",buffer); if(buffer[0]=='.'  && !buffer[1]) break;
		ref=strchr(buffer,0)-1; if(buffer[1] && *ref==':') *ref=0,str.Add(buffer,true);
	}
	rewind(file);
//    
	int last=-1,current;
	while(!feof(file)) {
		fscanf(file,"%s",buffer);
		if(buffer[0]=='.' && !buffer[1]) break;
		if(buffer[0]=='|') { gr_list.Close(); gr_list.New(); gr_list.Add(last);continue;}
		ref=strchr(buffer,0)-1; if(buffer[1] && *ref==':') { if(last>=0)gr_list.Close(); gr_list.New();*ref=0,last=-1;}
		current=str.Get(buffer);
		gr_list.Add(current);
		if(last<0) last=current;
	}
	fclose(file);
	gr_list.Close();
	gr_list.Sort();
}

// 

void RecurseRemove()	//    
{
	int n,m,i,last; bool rec;
		for(n=0; n<gr_list.GetSize();) {
		last=gr_list.Get(n,0); rec=false;
		for(m=n; m<gr_list.GetSize(); m++) {
			if(gr_list.Get(m,0)!=last) break;
			if(gr_list.Get(m,0)==gr_list.Get(m,1)) rec=true;}
		if(rec) {
			last=str.Dup(last);
			for(i=n; i<m; i++) {
				if(gr_list.Get(i,0)==gr_list.Get(i,1)) gr_list.DelSecond(i), gr_list.SetFirst(i,last);
				gr_list.Add(i,last); 
			}
			gr_list.Add(last); gr_list.Close();
		}
		n=m;
	} 
}

bool LeftFactor()	//   
{
	int n,m,s,c,last,i; bool res=false;
	for(n=0; n<gr_list.GetSize();) {
		s=-1;	//   
		for(m=n; m<gr_list.GetSize(); m++) {
			for(c=0; c<gr_list.GetCount(n) && c<gr_list.GetCount(m); c++) if(gr_list.Get(n,c)!=gr_list.Get(m,c)) break;
			if(s<0) s=c;
			if(c<2) break;
			if(c<s) s=c;
		}
		if(m-n>1) {
			res=true;
			last=gr_list.Get(n,0);
			gr_list.Add(last); for(i=1; i<s; i++) gr_list.Add(gr_list.Get(n,i));
			last=str.Dup(last); gr_list.Add(last); gr_list.Close();
			for(; n<m; n++) {
				for(i=1; i<s; i++) gr_list.DelSecond(n);
				gr_list.SetFirst(n,last);
			}
		} else if(n==m) n++;
		else n=m;
	}
	return res;
}

//  

void MakeSet()
{
	int n,t,m,p,l,c; bool next;
//  
	for(n=gr_list.GetSize()-1; n>=0; n--) {
		str.SetIndex(gr_list.Get(n,0),n);
		if(gr_list.GetCount(n)==1)
			str.SetEpsilon(gr_list.Get(n,0));
	}
//  
	n=str.Get("$"); 
	gr_list.AddFollowByType(0,n);
//   
	for(n=0; n<gr_list.GetSize(); n++) {
		t=gr_list.Get(n,1); if(t>=0 && str.isTerm(t)) 
			gr_list.AddFirstByIndex(n,t);
	}
// 
	int pass=0;
//	int u=str.Get("if-stmt1");
	do {
	next=false; pass++; 
		for(n=0; n<gr_list.GetSize(); n++) {
		c=gr_list.GetCount(n);
		p=gr_list.Get(n,0); t=gr_list.Get(n,1); l=gr_list.Get(n,c-1);
		if(!str.isTerm(t)) 
			next=gr_list.CopyFirstTypeToFirstIndex(t,n)||next;	//...
		if(c>1 && !str.isTerm(l)) {
			next=gr_list.CopyFollowIndexToFollowName(n,l)||next;
		}
		if(c>1 && str.isEps(t)) next=gr_list.CopyFirstTypeToFirstIndex(gr_list.Get(n,2),n)||next;
		for(m=2; m<c; m++) {
			p=gr_list.Get(n,m-1); t=gr_list.Get(n,m);
			if(str.isTerm(p)) continue;
			if(str.isTerm(t)) 
				next=gr_list.AddFollowByType(p,t)||next;
			else {
				next=gr_list.CopyFirstToFollowByType(t,p)||next;
				if(str.isEps(t)) 
					next=gr_list.CopyFollowToFollowByType(t,p)||next;
			}
		}
	}
	}while(next);
	printf("pass: %d\n",pass);
}

void MakeTable()
{
	gr_list.MakeTable();
}

//  
class stack_st{
public:
	int value; tree_st*root;
	stack_st(){}
	stack_st(int v) { value=v; root=0;}
	stack_st(int v,tree_st *r) { value=v; root=r;}
	stack_st(const stack_st &obj) { value=obj.value; root=obj.root; }
};



class Tester
{
	std::queue<int>line; //  
	std::stack<stack_st>stack; // 
	void Load();
	void Parse();
public:
	void Start();
}tester;

void Tester::Start()
{
	Load();
	Parse();
}

void Tester::Load()
{
	int n;
	char buffer[100];	//   !!!!
	FILE *file=fopen(FILENAME_TST,"rt");
	while(!feof(file)) {
		fscanf(file,"%s",buffer); if(buffer[0]=='.' && !buffer[1]) break;
		n=str.Get(buffer);
		line.push(n);
	}
	fclose(file);
	n=str.Get("$");
	line.push(n);
}


void Tester::Parse()
{
	FILE *file=fopen(FILENAME_LOG,"wt");	
	int t1,t2,r,n,t; stack_st st_item; tree_st *p_tree;
	memset(&tree,0,sizeof(tree));
	n=str.Get("$");
	stack.push(stack_st(n));
	stack.push(stack_st(0,&tree));
	printf("parse:");
	for(;;) {
		if(stack.empty() || line.empty()) break;
		t2=line.front(); 
		if(!str.isTerm(t2)) {printf("\ninternal err.\n\a");break;}
		st_item=stack.top(); stack.pop(); t1=st_item.value;
#ifdef _DEBUG
		printf(" (%s,%s)",str.GetName(t1),str.GetName(t2));
#endif
		if(t1==t2) {line.pop();printf(" %s",str.GetName(t2)); fprintf(file," %s",str.GetName(t2));continue;}
		if(table.find(pair_st(t1,t2))==table.end()) { printf("\nnot found.\n"); break;}
		r=table[pair_st(t1,t2)];
		for(n=gr_list.GetCount(r)-1; n; n--) { 
			t=gr_list.Get(r,n); //p_tree=0;
			if(str.isNative(t))
			{ 
				if(!str.isTerm(t)) p_tree=st_item.root->Add(t,r); 
				else p_tree=0;
			}
			else p_tree=st_item.root;
			stack.push(stack_st(t,p_tree));
		}
	}
	fclose(file);
	if(stack.empty() && line.empty()) printf("\nDone !!!\n");
	else {
		printf("\nParse error!!!!\n");
	}
}


void DumpXML(FILE *file,tree_st *root=&tree,int depth=0)
{
	int n;
	for(n=0; n<depth*3; n++) putc(' ',file);
	while(root->Count()==1) root=(*root->child)[0];
	if(root->Count()) {
		fprintf(file,"<%s id='%d'>\n",str.GetName(root->token),root->id);
		for(n=0; n<root->Count(); n++) DumpXML(file,(*root->child)[n],depth+1);
		for(n=0; n<depth*3; n++) putc(' ',file);
		fprintf(file,"</%s>\n",str.GetName(root->token));
	} else fprintf(file,"<%s id='%d'/>\n",str.GetName(root->token),root->id);
}



void main()
{
	FILE *file; bool next;
	ReadGR();
	Dump_Gr();
	RecurseRemove();
//	gr_list.Sort();
	do{
		next=LeftFactor();
		gr_list.Sort();
	}while(next);
	file=fopen(FILENAME_NEW,"wt"); Dump_Gr(file); fclose(file);
	MakeSet();
	MakeTable();
	file=fopen(FILENAME_TAB,"wt"); Dump_Tab(file); fclose(file);
	tester.Start();
	file=fopen(FILENAME_XML,"wt"); 
		fprintf(file,"<?xml version=\"1.0\"?>\n");
		DumpXML(file); fclose(file);
	printf("Press enter\n");
	getchar();
	return;
}

 
